import { AliasNode } from './alias-node.js';
import { OnNode } from './on-node.js';
import { FilterExpressionNode } from './operation-node-utils.js';
import { OperationNode } from './operation-node.js';
import { TableNode } from './table-node.js';
export declare type JoinTableNode = TableNode | AliasNode;
export declare type JoinType = 'InnerJoin' | 'LeftJoin' | 'RightJoin' | 'FullJoin';
export interface JoinNode extends OperationNode {
    readonly kind: 'JoinNode';
    readonly joinType: JoinType;
    readonly table: JoinTableNode;
    readonly on?: OnNode;
}
/**
 * @internal
 */
export declare const JoinNode: Readonly<{
    is(node: OperationNode): node is JoinNode;
    create(joinType: JoinType, table: JoinTableNode): JoinNode;
    createWithOn(joinType: JoinType, table: JoinTableNode, on: FilterExpressionNode): JoinNode;
    cloneWithOn(joinNode: JoinNode, filter: FilterExpressionNode): JoinNode;
    cloneWithOrOn(joinNode: JoinNode, filter: FilterExpressionNode): JoinNode;
}>;
